#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <gtk/gtk.h>
#include <errno.h>
#include <sys/wait.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "system.h"
void getOpenDir(int dirOnly,char dirName[],GtkWidget* widget,char widget_name[],int method){
  GtkWidget* errMessage=NULL;
  GtkWidget* txtMessage=NULL;
  GtkWidget* lstDirectories=NULL;
  GtkWidget* optDirectories=NULL;
  GtkWidget* optMenu=NULL;
  GtkWidget* menu_item=NULL;
  GtkCList* clist=NULL;
  GtkOptionMenu* omenu=NULL;
  struct dirent *direntries;
  struct stat st;
  struct listing list;
  DIR *dir;
  char temp[256],size[256],*text[0],cwd[1024],*tokenPtr;
  int length=0,i=0,j=0;
  errMessage=create_dlgMessage();
  txtMessage=lookup_widget(errMessage,"txtMessage");
  lstDirectories=lookup_widget(widget,"lstDirectories");
  optDirectories=lookup_widget(widget,"optDirectories");
  clist=(GtkCList*)lstDirectories;
  omenu=(GtkOptionMenu*)optDirectories;
  if(chdir(dirName)==-1){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG00,strlen(ERR_MSG00));
	gtk_widget_show(errMessage);
	goto end;
  }
  if((dir=opendir("."))==NULL){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG01,strlen(ERR_MSG01));
	gtk_widget_show(errMessage);
	goto end;
  }
  if((direntries=readdir(dir))==NULL){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG02,strlen(ERR_MSG02));
	gtk_widget_show(errMessage);
	goto end;
  }
  rewinddir(dir);
  while((direntries=readdir(dir))){
  	if(dirOnly==1){
	  if(stat(direntries->d_name,&st)){
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG04,strlen(ERR_MSG04));
		gtk_widget_show(errMessage);
		goto end;
	  }
	  if(S_ISDIR(st.st_mode)){
		strcpy((char*)&list.buffer1[length],direntries->d_name);
		length++;
	  }
	}else{
	  strcpy((char*)&list.buffer1[length],direntries->d_name);
	  if(stat((char*)&list.buffer1[length],&st)){
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG04,strlen(ERR_MSG04));
		gtk_widget_show(errMessage);
		goto end;
	  }
	  sprintf(size,"%ld",(long)st.st_size);
	  strcpy((char*)&list.buffer2[length],size);
	  length++;
	}
  }
  if(method==0){ //sort by name
	for(i=0;i<length;i++){
	  for(j=i+1;j<length;j++){
		if(strcmp((char*)&list.buffer1[i],(char*)&list.buffer1[j])>0){
		  strcpy(temp,(char*)&list.buffer1[j]);
		  strcpy(size,(char*)&list.buffer2[j]);
		  strcpy((char*)&list.buffer1[j],(char*)&list.buffer1[i]);
		  strcpy((char*)&list.buffer2[j],(char*)&list.buffer2[i]);
		  strcpy((char*)&list.buffer1[i],temp);
		  strcpy((char*)&list.buffer2[i],size);
		}
	  }
	}
  }else if(method==1){ //sort by size
	for(i=2;i<length;i++){
	  for(j=i+1;j<length;j++){
		if(atoi((char*)&list.buffer2[i])>atoi((char*)&list.buffer2[j])){
	  	  strcpy(temp,(char*)&list.buffer1[j]);
		  strcpy(size,(char*)&list.buffer2[j]);
		  strcpy((char*)&list.buffer1[j],(char*)&list.buffer1[i]);
		  strcpy((char*)&list.buffer2[j],(char*)&list.buffer2[i]);
		  strcpy((char*)&list.buffer1[i],temp);
		  strcpy((char*)&list.buffer2[i],size);
		}
	  }
	}
  }
  getcwd(cwd,sizeof(cwd));
  tokenPtr=strtok(cwd,"/");
  memset(temp,0x0,256);
  optMenu=gtk_menu_new();
  strcat(temp,"/");
  menu_item=gtk_menu_item_new_with_label(temp);
  gtk_menu_append(GTK_MENU(optMenu),menu_item);
  if(!strcmp(widget_name,"DirFrom"))
	gtk_signal_connect_object(GTK_OBJECT(menu_item),"activate",
  				        	  GTK_SIGNAL_FUNC(optItemChangedFrom),
					         (gpointer)g_strdup(temp)); 
  if(!strcmp(widget_name,"DirTo"))
	gtk_signal_connect_object(GTK_OBJECT(menu_item),"activate",
  				        	  GTK_SIGNAL_FUNC(optItemChangedTo),
					         (gpointer)g_strdup(temp)); 					
  if(!strcmp(widget_name,"TempDir"))
	gtk_signal_connect_object(GTK_OBJECT(menu_item),"activate",
  				        	  GTK_SIGNAL_FUNC(optItemChangedTemp),
					         (gpointer)g_strdup(temp)); 					
  gtk_widget_show(menu_item);
  memset(temp,0x0,256);
  while(tokenPtr!=NULL){
	while(tokenPtr!=NULL){
	  strcat(temp,"/");
	  strcat(temp,tokenPtr);
	  menu_item=gtk_menu_item_new_with_label(temp);
	  gtk_menu_prepend(GTK_MENU(optMenu),menu_item);
	  if(!strcmp(widget_name,"DirFrom"))
		gtk_signal_connect_object(GTK_OBJECT(menu_item),"activate",
  					        	  GTK_SIGNAL_FUNC(optItemChangedFrom),
						         (gpointer)g_strdup(temp)); 
	  if(!strcmp(widget_name,"DirTo"))
		gtk_signal_connect_object(GTK_OBJECT(menu_item),"activate",
  					        	  GTK_SIGNAL_FUNC(optItemChangedTo),
						         (gpointer)g_strdup(temp)); 	
	  if(!strcmp(widget_name,"TempDir"))
		gtk_signal_connect_object(GTK_OBJECT(menu_item),"activate",
  				        		  GTK_SIGNAL_FUNC(optItemChangedTemp),
					             (gpointer)g_strdup(temp)); 						
	  gtk_widget_show(menu_item);
	  tokenPtr=strtok(NULL,"/");
	}
  }
  gtk_option_menu_set_menu(omenu,optMenu);
  gtk_option_menu_set_history(omenu,(gint)optMenu);
  gtk_clist_clear(clist);
  gtk_clist_freeze(clist);
  for(i=2;i<length;i++){
	text[0]=(char*)&list.buffer1[i];
	gtk_clist_append(clist,text);
  }
  gtk_clist_thaw(clist);
  if(closedir(dir)!=0){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG03,strlen(ERR_MSG03));
	gtk_widget_show(errMessage);
	goto end;
  }
end:;
}

void getFromDir(int dirOnly,char dirName[],GtkWidget* widget,char widget_name[],int method){
  GtkWidget* errMessage=NULL;
  GtkWidget* txtMessage=NULL;
  GtkWidget* lstFrom=NULL;
  GtkWidget* lstTo=NULL;
  GtkCList* clist=NULL;
  GtkWidget* lblFrom;
  struct dirent *direntries;
  struct stat st;
  struct listing list;
  DIR *dir;
  char temp[256],size[256],*text[0];
  int length=0,i=0,j=0,a=0;
  errMessage=create_dlgMessage();
  txtMessage=lookup_widget(errMessage,"txtMessage");
  lblFrom=lookup_widget(widget,"lblFrom");
  strcat(dirName,"/");
  if(!strcmp(dirName,"//"))
	gtk_label_set_text(GTK_LABEL(lblFrom),"/");
  else
	gtk_label_set_text(GTK_LABEL(lblFrom),dirName);
  lstFrom=lookup_widget(widget,"lstFrom");
  lstTo=lookup_widget(widget,"lstTo");
  clist=(GtkCList*)lstFrom;
  if(chdir(dirName)==-1){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG00,strlen(ERR_MSG00));
	gtk_widget_show(errMessage);
	goto end;
  }
  if((dir=opendir("."))==NULL){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG01,strlen(ERR_MSG01));
	gtk_widget_show(errMessage);
	goto end;
  }
  if((direntries=readdir(dir))==NULL){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG02,strlen(ERR_MSG02));
	gtk_widget_show(errMessage);
	goto end;
  }
  rewinddir(dir);
  while((direntries=readdir(dir))){
  	if(dirOnly==1){
	  if(stat(direntries->d_name,&st)){
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG04,strlen(ERR_MSG04));
		gtk_widget_show(errMessage);
		goto end;
	  }
	  if(S_ISDIR(st.st_mode)){
		strcpy((char*)&list.buffer1[length],direntries->d_name);
		length++;
	  }
	}else{
	  strcpy((char*)&list.buffer1[length],direntries->d_name);
	  if(stat((char*)&list.buffer1[length],&st)){
		gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG04,strlen(ERR_MSG04));
		gtk_widget_show(errMessage);
		goto end;
	  }
	  if(S_ISDIR(st.st_mode)){
		sprintf((char*)&list.buffer1[length],"%s/",direntries->d_name);
		if(!strcmp((char*)&list.buffer1[length],"./"))//direntries->d_name
		  strcpy((char*)&list.buffer1[length],"../");
	  }
	  sprintf(size,"%ld",(long)st.st_size);
	  strcpy((char*)&list.buffer2[length],size);
	  length++;
	}
  }
  if(method==0){ //sort by name
	for(i=0;i<length;i++){
	  for(j=i+1;j<length;j++){
		if(strcmp((char*)&list.buffer1[i],(char*)&list.buffer1[j])>0){
		  strcpy(temp,(char*)&list.buffer1[j]);
		  strcpy(size,(char*)&list.buffer2[j]);
		  strcpy((char*)&list.buffer1[j],(char*)&list.buffer1[i]);
		  strcpy((char*)&list.buffer2[j],(char*)&list.buffer2[i]);
		  strcpy((char*)&list.buffer1[i],temp);
		  strcpy((char*)&list.buffer2[i],size);
		}
	  }
	}
  }else if(method==1){ //sort by size
	for(i=2;i<length;i++){
	  for(j=i+1;j<length;j++){
		if(atoi((char*)&list.buffer2[i])>atoi((char*)&list.buffer2[j])){
	  	  strcpy(temp,(char*)&list.buffer1[j]);
		  strcpy(size,(char*)&list.buffer2[j]);
		  strcpy((char*)&list.buffer1[j],(char*)&list.buffer1[i]);
		  strcpy((char*)&list.buffer2[j],(char*)&list.buffer2[i]);
		  strcpy((char*)&list.buffer1[i],temp);
		  strcpy((char*)&list.buffer2[i],size);
		}
	  }
	}
  }
  gtk_clist_clear(clist);
  gtk_clist_freeze(clist);
  if(!strcmp(dirName,"/"))
	a=2;
  else
	a=1;
  for(i=a;i<length;i++){
    text[0]=(char*)&list.buffer1[i];
	text[1]=(char*)&list.buffer2[i];
	gtk_clist_append(GTK_CLIST(lstFrom),text);
  }
  gtk_clist_thaw(clist);
  if(closedir(dir)!=0){
	gtk_text_insert(GTK_TEXT(txtMessage),NULL,NULL,NULL,ERR_MSG03,strlen(ERR_MSG03));
	gtk_widget_show(errMessage);
	goto end;
  }
end:;
}

int compareLists(GtkCList* lstFrom,GtkCList* lstTo){
  int i=0,j=0,lengthFrom=0,lengthTo=0,length=0;
  char *buffer,*bufferFrom,*bufferTo;
  char *pathFrom,result[1024];
  char *sts;
  GtkWidget* lblFrom=NULL;
  lblFrom=lookup_widget(GTK_WIDGET(lstFrom),"lblFrom");
  gtk_label_get(GTK_LABEL(lblFrom),&pathFrom);
  for(i=0;;i++){
	if(gtk_clist_get_text(lstFrom,i,0,&buffer)==0)
	  break;
	else
  	  if(strcmp(buffer,"../"))
  		lengthFrom++;
  }
  for(i=0;;i++){
	if(gtk_clist_get_text(lstTo,i,0,&buffer)==0)
	  break;
	else
  	  if(strcmp(buffer,"../"))
  		lengthTo++;
  }
  gtk_clist_freeze(lstFrom);
  gtk_clist_freeze(lstTo);
  for(i=lengthFrom;i>0;i--){
	gtk_label_get(GTK_LABEL(lblFrom),&pathFrom);
	gtk_clist_get_text(lstFrom,i,0,&bufferFrom);
	sprintf(result,"%s%s",pathFrom,bufferFrom);
	for(j=0;j<lengthTo;j++){
	  gtk_clist_get_text(lstTo,j,0,&bufferTo);
	  if(strcmp(result,bufferTo)==0)
		gtk_clist_remove(lstFrom,i);
	}
  }
  gtk_clist_thaw(lstFrom);
  gtk_clist_thaw(lstTo);
  for(i=0;;i++){
	if(gtk_clist_get_text(lstFrom,i,0,&buffer)==0)
	  break;
	else
  	  if(strcmp(buffer,"../"))
		length++;
  }
  sts=(char*)malloc(256);
  j=0;
  for(i=0;i<selFrom->numrows;i++)
	if(selFrom[i].row==(int*)1)
	  j++;
  sprintf(sts,"Listed Files : %d Selected Files : %d",selFrom->numrows,j);
  gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(winMain,"stsFrom")),GPOINTER_TO_INT(
  gtk_statusbar_get_context_id(GTK_STATUSBAR(lookup_widget(winMain,"stsFrom")),"stsFrom")),sts);
  free(sts);
  sts=(char*)malloc(256);
  memset(sts,0x0,sizeof(sts));
  j=0;
  for(i=0;i<selTo->numrows;i++)
	if(selTo[i].row==(int*)1)
	  j++;
  sprintf(sts,"Listed Files : %d Selected Files : %d",selTo->numrows,j);
  gtk_statusbar_push(GTK_STATUSBAR(lookup_widget(winMain,"stsTo")),GPOINTER_TO_INT(
  gtk_statusbar_get_context_id(GTK_STATUSBAR(lookup_widget(winMain,"stsTo")),"stsTo")),sts);
  free(sts);
  return length;
}

int mySystem(char *exe[]){
  int pid=0,status=0,stuff=0;
  pid=fork();
  if(pid==-1)
    return -1;
  if(pid==0){
    stuff=execv(exe[0],exe);
    exit(127);
  }
  do{
    if(waitpid(pid,&status,0)==-1){
      if(errno!=EINTR)
  	return -1;
    }else
      return status;
  }while(1);
}
